
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Notification_record_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notification_record_items = await db.notification_record_items.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        tested_at: data.tested_at
        ||
        null
            ,
            
        evidence_reference: data.evidence_reference
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await notification_record_items.setNotification_record( data.notification_record || null, {
            transaction,
        });
        
        await notification_record_items.setAuthentication_method( data.authentication_method || null, {
            transaction,
        });
        
        await notification_record_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return notification_record_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const notification_record_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                tested_at: item.tested_at
            ||
            null
            ,
            
                evidence_reference: item.evidence_reference
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const notification_record_items = await db.notification_record_items.bulkCreate(notification_record_itemsData, { transaction });

        // For each item created, replace relation files
        

        return notification_record_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const notification_record_items = await db.notification_record_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.tested_at !== undefined) updatePayload.tested_at = data.tested_at;
        
        
        if (data.evidence_reference !== undefined) updatePayload.evidence_reference = data.evidence_reference;
        
        
        updatePayload.updatedById = currentUser.id;

        await notification_record_items.update(updatePayload, {transaction});

        
        
        if (data.notification_record !== undefined) {
            await notification_record_items.setNotification_record(
              
              data.notification_record,
              
              { transaction }
            );
        }
        
        if (data.authentication_method !== undefined) {
            await notification_record_items.setAuthentication_method(
              
              data.authentication_method,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await notification_record_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return notification_record_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notification_record_items = await db.notification_record_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of notification_record_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of notification_record_items) {
                await record.destroy({transaction});
            }
        });


        return notification_record_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const notification_record_items = await db.notification_record_items.findByPk(id, options);

        await notification_record_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await notification_record_items.destroy({
            transaction
        });

        return notification_record_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const notification_record_items = await db.notification_record_items.findOne(
            { where },
            { transaction },
        );

        if (!notification_record_items) {
            return notification_record_items;
        }

        const output = notification_record_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.notification_record = await notification_record_items.getNotification_record({
            transaction
        });
        
        
        output.authentication_method = await notification_record_items.getAuthentication_method({
            transaction
        });
        
        
        output.organizations = await notification_record_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.notification_records,
        as: 'notification_record',
        
        where: filter.notification_record ? {
          [Op.or]: [
            { id: { [Op.in]: filter.notification_record.split('|').map(term => Utils.uuid(term)) } },
            {
              record_hash: {
                [Op.or]: filter.notification_record.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.authentication_methods,
        as: 'authentication_method',
        
        where: filter.authentication_method ? {
          [Op.or]: [
            { id: { [Op.in]: filter.authentication_method.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.authentication_method.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.evidence_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notification_record_items',
                        'evidence_reference',
                        filter.evidence_reference,
                    ),
                };
            }
            

            
            

            
            if (filter.tested_atRange) {
                const [start, end] = filter.tested_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tested_at: {
                    ...where.tested_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tested_at: {
                    ...where.tested_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.notification_record_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'notification_record_items',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.notification_record_items.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

